<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<title>TM Server Test</title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
</head>
<body bgcolor="#E9E9E9" scroll="yes" leftmargin="0" topmargin="0" marginwidth="0" marginheight="0">
<center>
<h2>Test if your TrackMania Server is responding</h2>
<br/>
<?php

// get port value
if(isset($_REQUEST['port'])){
	$port = $_REQUEST['port']+0;
}else{
	$port = 2350;
}

// get port value
if(isset($_REQUEST['p2port'])){
	$p2port = $_REQUEST['p2port']+0;
}else{
	$p2port = 3450;
}

// get port value
if(isset($_REQUEST['xmlport'])){
	$xmlport = $_REQUEST['xmlport']+0;
}else{
	$xmlport = '';
}

// get port value
if(isset($_REQUEST['game'])){
	$game = $_REQUEST['game'];
}else{
	$game = 'TMF';
}

// get IP value
if(isset($_REQUEST['ip'])){
	$ip = $_REQUEST['ip'];

	// if ip was given then test TM server
	echo "<hr/><br/>\n";
	TestTCP($ip,$port,$game,$p2port,$xmlport);
	echo "</strong><br/><hr/>\n";

}elseif(isset($_SERVER["REMOTE_ADDR"])){
	// get navigator IP
	$ip = $_SERVER["REMOTE_ADDR"];

}else{
	$ip = "";
}

$sel1 = ($game=='TMN')?'selected':'';
$sel2 = ($game=='TMS/TMO')?'selected':'';
$sel3 = ($game=='TMF')?'selected':'';
		 
// make the form
?>
<form action='' method='get'>
<p>TM Server IP or Name <input type=text value='<?=$ip?>' name='ip' maxlength='50' size='25'>
<p>Server port <input type=text value='<?=$port?>' name='port' maxlength='5' size='5'>
<p>Server p2p port <input type=text value='<?=$p2port?>' name='p2port' maxlength='5' size='5'>
<p>Server xmlrpc port <input type=text value='<?=$xmlport?>' name='xmlport' maxlength='5' size='5'>
<p>Game <select name='game'>
<option <?=$sel1?> value='TMN'>TMN</option>
<option <?=$sel2?> value='TMS/TMO'>TMS/TMO</option>
<option <?=$sel3?> value='TMF'>TMF</option>
</select>
<p><input type=submit value='Start test !' name='submit'>
</form>
<br/>
<br/>
<br/>
<br/><small>This test is done only on TCP,
<br/>btw, if your TCP redirection works, then you should easily succeed 
<br/>to configure to your UDP redirection on the same port number...
<br/>
<br/>Note: the main port should be tcp and udp, the p2p port tcp only.
<br/>
<br/>Note2: the xmlrpc port is tcp only and should be opened only if needed !...
<br/></small>

<?php


//phpinfo(32);

function TestTCP($ip,$port,$game,$p2port,$xmlport){

	if($game=='TMN'){
		$buf1 = "\x0E\x00\x00\x00\x82\x03\xBC\x96\x10\xC5\x05\x00\x00\x00\x08\x00\x00\x00";
		$buf2 = "\x12\x00\x00\x00\x82\x03\xE8\xA4\x2B\xEB\x05\x00\x00\x00\x07\x00\x00\x00\xB5\x7F\x03\x00";
		//uf2 = "\x12\x00\x00\x00\x82\x03\x27\xF2\x22\xFF\x05\x00\x00\x00\x07\x00\x00\x00\xA3\xAE\x0D\x00";
		//                                 ^^  ^^  ^^  ^^                                  ^^  ^^  ^^  ^^
		//                                 E8  A4  2B  EB                                  B5  7F  03  00  16/06/06 22h
		//                                 3B  E2  E9  4D                                  85  B8  01  00  25/06/06 9h
		//                                 27  F2  22  FF                                  A3  AE  0D  00  25/06/06 9h07
	}elseif($game=='TMS/TMO'){
		//TMS
		$buf1 = "\x0E\x00\x00\x00\x82\x03\x8B\x94\x33\x74\x04\x00\x00\x00\x08\x00\x00\x00";
		$buf2 = "\x12\x00\x00\x00\x82\x03\x61\x1C\x7C\xCE\x04\x00\x00\x00\x07\x00\x00\x00\x39\xA8\x03\x00";
		//TMO
		//$buf1 = "\x0E\x00\x00\x00\x82\x03\x8B\x94\x33\x74\x04\x00\x00\x00\x08\x00\x00\x00";
		//$buf2 = "\x12\x00\x00\x00\x82\x03\xDB\xC7\x30\xA8\x04\x00\x00\x00\x07\x00\x00\x00\xA2\x69\x02\x00";
	}elseif($game=='TMF'){
		//TMF
		$buf1 = "\x0e\x00\x00\x00\x82\x03\x99\xf8\x95\x58\x07\x00\x00\x00\x08\x00\x00\x00";
		$buf2 = "\x12\x00\x00\x00\x82\x03\x04\x0e\x5f\xb4\x07\x00\x00\x00\x07\x00\x00\x00\xe2\x07\x01\x00";
	}else{
		echo "<font color='#dd0000'>$game: unknown type of TM server !</font><br/>\n";
		return;
	}
	echo "<font color='#0000aa'>Test $game serveur at $ip:$port ...</font><br/>\n";

	// TM main port test
	if($port > 0){
		$fp = @fsockopen("tcp://$ip", $port, $errno, $errstr, 2);
		if ($fp===false) {
			echo "<br/><font color='#dd0000'><strong>No $game server main port</strong> there (connection error $errno: $errstr) !</font><br/>\n";
		}else{
			fwrite($fp, $buf1);
			fwrite($fp, $buf2);
			stream_set_timeout($fp,2);
			$res = fread($fp, 1600);
			if(strpos($res,"#SRV#")!==false){
				echo "<br/><font color='#00aa00'><strong>A $game server</strong> <u>$ip</u> is responding on <strong>TCP port $port</strong> !</font><br/>\n";
				$res = true;
				
			}elseif($res===false || strlen($res)<=0){
				echo "<br/><font color='#dd7700'><strong>The connection succeeded on TCP port $port !... but no response to the specific request ($game) :<br>it can be another (or unknown) TM dedicated version, or it can be some other service than a TM server main port !</strong></font><br/>\n";
				
			}else{
				echo "<br/><font color='#aaaa00'><strong>Not a $game server</strong> there (bad response) !</font><br/>\n";
			}
			fclose($fp);
		}
	}

	// TM P2P port test
	if($p2port > 0){
		$fp = @fsockopen("tcp://$ip", $p2port, $errno, $errstr, 2);
		if ($fp===false) {
			echo "<br/><font color='#dd0000'><strong>No $game server p2p port is joignable on tcp $p2port</strong> (connection error $errno: $errstr) !</font><br/>\n";
		}else{
			echo "<br/><font color='#00aa00'><u>$ip</u> is responding on <strong>TCP port $p2port</strong> ! (but can't be sure that it is a TM P2P port)</font><br/>\n";
			fclose($fp);
		}
	}

	// TM xmlrpc port test
	if($xmlport > 0){
		$fp = @fsockopen("tcp://$ip", $xmlport, $errno, $errstr, 2);
		if ($fp===false) {
			echo "<br/><font color='#dd0000'><strong>No $game server xmlrpc port is joignable on tcp $xmlport</strong> (connection error $errno: $errstr) !<br/>Btw it can also just not be reachable from this site/script ip, if that port is firewalled, or if xmlrpc_allowremote is false !</font><br/>\n";
		}else{
			stream_set_timeout($fp,2);
			$res = fread($fp, 4);
			$res .= fread($fp, 80);
			if(strpos($res,"GBXRemote 2")!==false){
				echo "<br/><font color='#00aa00'><strong>A TM server XMLRPC is responding on TCP port $xmlport</strong> !</font><br/>\n";
				$res = true;
				
			}elseif($res===false || strlen($res)<=0){
				echo "<br/><font color='#dd7700'><strong>The connection succeeded on TCP port $xmlport !... but no xmlrpc response !</strong><br/>This means that this is not a TM xmlrpc port, or that xmlrpc_allowremote is set to a specific ip (different than this site/script one)</font><br/>\n";
				
			}else{
				echo "<br/><font color='#aaaa00'><strong>Not a TM server xmlrpc port on tcp $xmlport</strong> !</font><br/>\n";
				var_dump($res);
			}
			fclose($fp);
		}
	}
}


?>
</center>
</body>
</html>
